open Attribute_value
let attribute_parsers =
  [("a_ontouchcancel", (nowrap string));
  ("a_ontouchmove", (nowrap string));
  ("a_ontouchend", (nowrap string));
  ("a_ontouchstart", (nowrap string));
  ("a_onmousemove", (nowrap string));
  ("a_onmouseout", (nowrap string));
  ("a_onmouseover", (nowrap string));
  ("a_onmouseup", (nowrap string));
  ("a_onmousedown", (nowrap string));
  ("a_onclick", (nowrap string));
  ("a_onzoom", (nowrap string));
  ("a_onunload", (nowrap string));
  ("a_onscroll", (nowrap string));
  ("a_onresize", (nowrap string));
  ("a_onrepeat", (nowrap string));
  ("a_onload", (nowrap string));
  ("a_onfocusout", (nowrap string));
  ("a_onfocusin", (nowrap string));
  ("a_onerror", (nowrap string));
  ("a_onend", (nowrap string));
  ("a_onbegin", (nowrap string));
  ("a_onactivate", (nowrap string));
  ("a_onabort", (nowrap string));
  ("a_stroke_opacity", (wrap float));
  ("a_stroke_dashoffset", (wrap svg_length));
  ("a_stroke_dasharray", (wrap (spaces_or_commas svg_length)));
  ("a_stroke_miterlimit", (wrap float));
  ("a_stroke_linejoin", (wrap variant));
  ("a_stroke_linecap", (wrap variant));
  ("a_stroke_width", (wrap svg_length));
  ("a_stroke", (wrap paint));
  ("a_stop_opacity", (wrap float));
  ("a_stop_color", (wrap string));
  ("a_dominant_baseline", (wrap variant));
  ("a_alignment_baseline", (wrap variant));
  ("a_name", (wrap string));
  ("a_string", (wrap string));
  ("a_overline_thickness", (wrap float));
  ("a_overline_position", (wrap float));
  ("a_strikethrough_thickness", (wrap float));
  ("a_strikethrough_position", (wrap float));
  ("a_underline_thickness", (wrap float));
  ("a_underline_position", (wrap float));
  ("a_v_hanging", (wrap float));
  ("a_v_mathematical", (wrap float));
  ("a_v_alphabetic", (wrap float));
  ("a_videographic", (wrap float));
  ("a_hanging", (wrap float));
  ("a_mathematical", (wrap float));
  ("a_alphabetic", (wrap float));
  ("a_ideographic", (wrap float));
  ("a_bbox", (wrap string));
  ("a_widths", (wrap string));
  ("a_ascent", (wrap float));
  ("a_accent_height", (wrap float));
  ("a_x_height", (wrap float));
  ("a_cap_height", (wrap float));
  ("a_slope", (wrap float));
  ("a_stemh", (wrap float));
  ("a_stemv", (wrap float));
  ("a_units_per_em", (wrap string));
  ("a_unicode_range", (wrap string));
  ("a_font_size", (wrap string));
  ("a_font_stretch", (wrap string));
  ("a_font_weight", (wrap string));
  ("a_font_variant", (wrap string));
  ("a_font_style", (wrap string));
  ("a_font_family", (wrap string));
  ("a_k", (wrap string));
  ("a_g2", (wrap string));
  ("a_g1", (wrap string));
  ("a_u2", (wrap string));
  ("a_u1", (wrap string));
  ("a_lang", (wrap string));
  ("a_arabic_form", (wrap variant));
  ("a_orientation", (wrap variant));
  ("a_glyph_name", (wrap string));
  ("a_unicode", (wrap string));
  ("a_vert_adv_y", (wrap float));
  ("a_vert_origin_y", (wrap float));
  ("a_vert_origin_x", (wrap float));
  ("a_horiz_adv_x", (wrap float));
  ("a_horiz_origin_y", (wrap float));
  ("a_horiz_origin_x", (wrap float));
  ("a_animateTransform_type", (wrap variant));
  ("a_path", (wrap string));
  ("a_keyPoints", (wrap (semicolons float)));
  ("a_accumulate", (wrap variant));
  ("a_additive", (wrap variant));
  ("a_by", (wrap string));
  ("a_to", (wrap string));
  ("a_from", (wrap string));
  ("a_keySplines", (wrap (spaces string)));
  ("a_keyTimes", (wrap (spaces string)));
  ("a_animation_values", (wrap (spaces string)));
  ("a_calcMode", (wrap variant));
  ("a_fill_rule", (wrap fill_rule));
  ("a_animation_fill", (wrap variant));
  ("a_fill", (wrap paint));
  ("a_repeatDur", (wrap string));
  ("a_repeatCount", (wrap string));
  ("a_restart", (wrap variant));
  ("a_max", (wrap string));
  ("a_min", (wrap string));
  ("a_dur", (wrap string));
  ("a_begin", (wrap string));
  ("a_attributeType", (wrap variant));
  ("a_attributeName", (wrap string));
  ("a_viewTarget", (wrap string));
  ("a_target", (wrap string));
  ("a_xlink_actuate", (wrap variant));
  ("a_xlink_show", (wrap variant));
  ("a_feTurbulence_type", (wrap variant));
  ("a_stitchTiles", (wrap variant));
  ("a_seed", (wrap float));
  ("a_numOctaves", (wrap int));
  ("a_baseFrenquency", (wrap number_pair));
  ("a_radius", (wrap number_pair));
  ("a_feMorphology_operator", (wrap variant));
  ("a_stdDeviation", (wrap number_pair));
  ("a_yChannelSelector", (wrap variant));
  ("a_xChannelSelector", (wrap variant));
  ("a_scale", (wrap float));
  ("a_diffuseConstant", (wrap float));
  ("a_surfaceScale", (wrap float));
  ("a_preserveAlpha", (wrap bool));
  ("a_edgeMode", (wrap variant));
  ("a_targetY", (wrap int));
  ("a_targetX", (wrap int));
  ("a_kernelUnitLength", (wrap number_pair));
  ("a_bias", (wrap float));
  ("a_divisor", (wrap float));
  ("a_kernelMatrix", (wrap (spaces_or_commas float)));
  ("a_order", (wrap number_pair));
  ("a_k4", (wrap float));
  ("a_k3", (wrap float));
  ("a_k2", (wrap float));
  ("a_k1", (wrap float));
  ("a_feComposite_operator", (wrap variant));
  ("a_transfer_offset", (wrap float));
  ("a_exponent", (wrap float));
  ("a_amplitude", (wrap float));
  ("a_intercept", (wrap float));
  ("a_tableValues", (wrap (spaces_or_commas float)));
  ("a_transfer_type", (wrap variant));
  ("a_values", (wrap (spaces_or_commas float)));
  ("a_feColorMatrix_type", (wrap variant));
  ("a_mode", (wrap variant));
  ("a_limitingConeAngle", (wrap float));
  ("a_specularConstant", (wrap float));
  ("a_specularExponent", (wrap float));
  ("a_pointsAtZ", (wrap float));
  ("a_pointsAtY", (wrap float));
  ("a_pointsAtX", (wrap float));
  ("a_elevation", (wrap float));
  ("a_azimuth", (wrap float));
  ("a_in2", (wrap in2));
  ("a_in", (wrap in_));
  ("a_result", (wrap string));
  ("a_filterRes", (wrap number_pair));
  ("a_primitiveUnits", (wrap variant));
  ("a_maskContentUnits", (wrap variant));
  ("a_maskUnits", (wrap variant));
  ("a_clipPathUnits", (wrap variant));
  ("a_patternTransform", (wrap (spaces_or_commas transform)));
  ("a_patternContentUnits", (wrap variant));
  ("a_patternUnits", (wrap variant));
  ("a_offset", (wrap offset));
  ("a_fy", (wrap svg_length));
  ("a_fx", (wrap svg_length));
  ("a_spreadMethod", (wrap variant));
  ("a_gradientTransform", (wrap (spaces_or_commas transform)));
  ("a_gradientUnits", (wrap variant));
  ("a_rendering_intent", (wrap variant));
  ("a_local", (wrap string));
  ("a_orient", (wrap (option "auto" angle)));
  ("a_markerHeight", (wrap svg_length));
  ("a_markerWidth", (wrap svg_length));
  ("a_refY", (wrap svg_length));
  ("a_refX", (wrap svg_length));
  ("a_markerUnits", (wrap variant));
  ("a_format", (wrap string));
  ("a_glyphRef", (wrap string));
  ("a_spacing", (wrap variant));
  ("a_method", (wrap variant));
  ("a_startOffset", (wrap svg_length));
  ("a_rotate", (wrap (spaces_or_commas float)));
  ("a_text_rendering", (wrap variant));
  ("a_text_decoration", (wrap variant));
  ("a_text_anchor", (wrap variant));
  ("a_textLength", (wrap svg_length));
  ("a_lengthAdjust", (wrap variant));
  ("a_dy_list", (wrap (spaces_or_commas svg_length)));
  ("a_dx_list", (wrap (spaces_or_commas svg_length)));
  ("a_dy", (wrap float));
  ("a_dx", (wrap float));
  ("a_y_list", (wrap (spaces_or_commas svg_length)));
  ("a_x_list", (wrap (spaces_or_commas svg_length)));
  ("a_points", (wrap points));
  ("a_y2", (wrap svg_length));
  ("a_x2", (wrap svg_length));
  ("a_y1", (wrap svg_length));
  ("a_x1", (wrap svg_length));
  ("a_r", (wrap svg_length));
  ("a_cy", (wrap svg_length));
  ("a_cx", (wrap svg_length));
  ("a_ry", (wrap svg_length));
  ("a_rx", (wrap svg_length));
  ("a_pathLength", (wrap float));
  ("a_d", (wrap string));
  ("a_viewBox", (wrap fourfloats));
  ("a_transform", (wrap (spaces_or_commas transform)));
  ("a_style", (wrap string));
  ("a_class", (wrap (spaces string)));
  ("a_xlink_title", (wrap string));
  ("a_media", (wrap (commas string)));
  ("a_type", (wrap string));
  ("a_xml_space", (wrap variant));
  ("a_xml_lang", (wrap string));
  ("a_xml_base", (wrap string));
  ("a_user_data", (wrap string));
  ("a_id", (wrap string));
  ("a_externalRessourcesRequired", (wrap bool));
  ("a_systemLanguage", (wrap (commas string)));
  ("a_requiredExtensions", (wrap (spaces string)));
  ("a_requiredFeatures", (wrap (spaces string)));
  ("a_xlink_href", (wrap string));
  ("a_href", (wrap string));
  ("a_zoomAndPan", (wrap variant));
  ("a_contentStyleType", (wrap string));
  ("a_contentScriptType", (wrap string));
  ("a_preserveAspectRatio", (wrap string));
  ("a_height", (wrap svg_length));
  ("a_width", (wrap svg_length));
  ("a_y", (wrap svg_length));
  ("a_x", (wrap svg_length));
  ("a_baseProfile", (wrap string));
  ("a_version", (wrap string))]
let renamed_attributes =
  [("a_animateTransform_type", "type", ["animateTransform"]);
  ("a_animation_values", "values", ["animation"]);
  ("a_animation_fill", "fill", ["animation"]);
  ("a_feTurbulence_type", "type", ["feTurbulence"]);
  ("a_feMorphology_operator", "operator", ["feMorphology"]);
  ("a_feComposite_operator", "operator", ["feComposite"]);
  ("a_transfer_offset", "offset",
    ["feFuncA"; "feFuncB"; "feFuncG"; "feFuncR"]);
  ("a_transfer_type", "type", ["feFuncA"; "feFuncB"; "feFuncG"; "feFuncR"]);
  ("a_feColorMatrix_type", "type", ["feColorMatrix"]);
  ("a_dy_list", "dy", ["altGlyph"; "tref"; "tspan"; "text"]);
  ("a_dx_list", "dx", ["altGlyph"; "tref"; "tspan"; "text"]);
  ("a_y_list", "y", ["altGlyph"; "tref"; "tspan"; "text"]);
  ("a_x_list", "x", ["altGlyph"; "tref"; "tspan"; "text"])]
let labeled_attributes = []
open Element_content
let element_assemblers =
  [("font_face_name", nullary);
  ("font_face_format", nullary);
  ("font_face_uri", star);
  ("font_face_src", star);
  ("font_face", nullary);
  ("vkern", nullary);
  ("hkern", nullary);
  ("missing_glyph", star);
  ("glyph", star);
  ("font", star);
  ("animateTransform", star);
  ("animateColor", star);
  ("mpath", star);
  ("animateMotion", star);
  ("set", star);
  ("animation", star);
  ("script", unary);
  ("view", star);
  ("a", star);
  ("cursor", star);
  ("feTurbulence", star);
  ("feTile", star);
  ("feSpecularLighting", star);
  ("feOffset", star);
  ("feMorphology", star);
  ("feMerge", star);
  ("feImage", star);
  ("feGaussianBlur", star);
  ("feFlood", star);
  ("feDisplacementMap", star);
  ("feDiffuseLighting", star);
  ("feConvolveMatrix", star);
  ("feComposite", star);
  ("feFuncR", star);
  ("feFuncB", star);
  ("feFuncG", star);
  ("feFuncA", star);
  ("feComponentTransfer", star);
  ("feColorMatrix", star);
  ("feBlend", star);
  ("feSpotLight", star);
  ("fePointLight", star);
  ("feDistantLight", star);
  ("filter", star);
  ("clipPath", star);
  ("pattern", star);
  ("stop", star);
  ("radialGradient", star);
  ("linearGradient", star);
  ("color_profile", star);
  ("marker", star);
  ("glyphRef", nullary);
  ("altGlyphItem", star);
  ("altGlyphDef", unary);
  ("altGlyph", unary);
  ("textPath", star);
  ("tref", star);
  ("tspan", star);
  ("text", star);
  ("polygon", star);
  ("polyline", star);
  ("line", star);
  ("ellipse", star);
  ("circle", star);
  ("rect", star);
  ("path", star);
  ("style", unary);
  ("switch", star);
  ("image", star);
  ("use", star);
  ("symbol", star);
  ("title", unary);
  ("desc", unary);
  ("defs", star);
  ("g", star);
  ("svg", star)]
let renamed_elements = []
